package com.bundt.price.managedBeans

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import java.io.Serializable;
import java.util.logging.Logger;
import java.util.logging.Level;
import javax.faces.event.ActionEvent
import javax.faces.event.AjaxBehaviorEvent

import org.richfaces.component.UIDataTable;

import com.bundt.price.broker.BundtItemBroker;
import com.bundt.price.domain.BundtItem

@ManagedBean
@SessionScoped
class BundtItemManagedBean extends ManagedBeanBase implements Serializable {
	private static final long serialVersionUID = 1L

	private static final Logger logger
	static {
		logger = Logger.getLogger(BundtItemManagedBean.class.getName())
	}
		
	transient BundtItemBroker itemBroker

	BundtItemManagedBean() {
		init()
	}
	
	private def init() {
		itemBroker = new BundtItemBroker()
	}

	UIDataTable itemTable;
		
	List itemList

	def getItemList() {
		if (itemList == null) {
			itemList = []
			retrieveItemList();
		}
		return itemList
	}
	
	private def retrieveItemList() {
		try {
			itemList = itemBroker.findAllItems()
		} catch (Throwable t) {
			errorMessages << "An exception occurred while retrieving a list of all Items: ${t.getMessage()}"
			logger.log(Level.SEVERE, t.getMessage(), t)
		}
	}
	
	BundtItem selectedItem
	
	public void setSelectedItem(BundtItem selectedItem) {
		this.selectedItem = selectedItem;
	}
	
	/*******  Add new Bundt Item action ************/
	def newBundtItem() {
		selectedItem = new BundtItem();
		getItemList().add(selectedItem)
		Collections.sort(itemList)
		System.out.println("newBundtItem created.")
		//return "bundtItem";
		return "";
	}

	int selectedNdx	
	
	def saveItem() {
		
		return "bundtItemList"
	}
	
	def calculateCost(AjaxBehaviorEvent abe) {
		selectedItem.calculateCost();
	}
}
